#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "EContext.h"
#include "AnimationPreviewPresenter.generated.h"

class UUserWidget;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API UAnimationPreviewPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> AnimationPreviewWidgetClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	EContext ObservedContext;

private:
	UFUNCTION(BlueprintCallable)
	void OnContextLeave(EContext context);

	UFUNCTION(BlueprintCallable)
	void OnContextEnter(EContext context);

	UFUNCTION(BlueprintCallable)
	bool IsContextEntered() const;

public:
	UAnimationPreviewPresenter();
};

FORCEINLINE uint32 GetTypeHash(const UAnimationPreviewPresenter) { return 0; }
